/** 
Considere la estructura de datos para representar el voto de un ciudadano de las prcticas anteriores, as como las funciones desarrolladas para su manipulacin. 
Declare una estructura de datos homognea (un array unidimensional 'generales'), en el que se almacenar el conjunto de votos emitidos.
La declaracin ha de ser LOCAL a la funcin principal.
Implemente una funcin 'cargarVotosDeFichero()' que abra un fichero que contiene la informacin asociada a cada uno de los votos y la almacene en el array unidimensional 'generales'.
Desarrolle una funcin 'guardarVotosEnFichero()' que solicit el nombre del fichero donde se desea guardar la informacin y almacene en el mismo la informacin contenida en el array unidimensional 'generales'. 
Elabore una funcin 'menu()' que muestre el conjunto de opciones disponibles para la manipulacin de los votos emitidos.
En la funcin 'main()' compruebe el correcto funcionamieto de los subprogramas desarrollados. Los ficheros de entrada seguiran el formato de 'entrada.dat'.

N        -- Numero de votos emitidos (entero)
i_1      -- Voto numero 1 : Isla (entero corto)
p_1      --                 Partido Congreso (entero corto)
s1_1     --                 Primer Senador (entero corto)
s2_1     --                 Segundo Senador (entero corto) 
i_2      -- Voto numero 2 : Isla (entero corto)
p_2      --                 Partido Congreso (entero corto)
s1_2     --                 Primer Senador (entero corto)
s2_2     --                 Segundo Senador (entero corto) 
...
i_N      -- Voto numero N : Isla (entero corto)
p_N      --                 Partido Congreso (entero corto)
s1_N     --                 Primer Senador (entero corto)
s2_N     --                 Segundo Senador (entero corto) 

// #include "elecciones.h"
**/

#include <iostream> // cin, cout
#include <fstream> // in, out

using namespace std;

/*
const int CENSO = 5;
*/
const int MAXNOMBRE = 20;

struct voto {
  short isla;
  short congreso;
  short senado[2]; 
}; /* votoActual; */

#include "elecciones_modificada.h"
/* OJO COMENTAR En elecciones.h lo siguiente:
       
struct voto {
  short isla;
	short congreso;
	short senado[2]; 
} votoActual;
*/

int cargarVotosDeFichero(struct voto *);

void guardarVotosEnFichero(struct voto *, int);

int votacion20N(struct voto *);

void guardarEnResultadosVotacion(struct voto *, int);

void LeerVoto(iostream &in, struct voto *v) {
  in >> v->isla;
  in >> v->congreso;
  in >> v->senado[0];
  if (v->isla < 2) // isla mayor
    in >> v->senado[1];
} /* LeerVoto */

int LeerVotacion(iostream &in, struct voto *v) {
int num_votos, i;
    
  in >> num_votos;
  
  if (num_votos > CENSO)
    num_votos = CENSO;
    
  for (i = 0; i < num_votos; i++) 
    LeerVoto(in, &v[i]);

  return num_votos;
} /* LeerVotacion */

void EscribirVoto(iostream &out, struct voto *v) {
  out << v->isla << endl;
  out << v->congreso << endl;
  out << v->senado[0] << endl;
  if (v->isla < 2) // isla mayor
    out << v->senado[1] << endl;             
} /* EscribirVoto */

void EscribirVotacion(iostream &out, struct voto *v, int num_votos) {
int i;

  out << num_votos << endl;
  for (i = 0; i < num_votos; i++)
    EscribirVoto(out, &v[i]);
} /* EscribirVotacion */

int main(void) {
int n_votos, i;
struct voto generales[CENSO];
  
  n_votos = cargarVotosDeFichero(generales);
  
  cout << "Numero de votos = " << n_votos << endl;
  for (i = 0; i < n_votos; i++) {
    cout << "Voto " << i+1 << ": Isla: " << generales[i].isla << " Congreso: " << generales[i].congreso << " Senado: " << generales[i].senado[0];
    if (generales[i].isla < 2)
      cout << " " << generales[i].senado[1];
    cout << endl;       
  } /* for */

  n_votos = votacion20N(generales);
  guardarEnResultadosVotacion(generales, n_votos);
  
  guardarVotosEnFichero(generales, n_votos);
  int tmp;
  cin >> tmp;
}

/* La funcin devuelve el nmero de votos o -1 en error. En el array "gen" guarda los votos */
int cargarVotosDeFichero(struct voto *gen) {
char nombre_fichero_entrada[MAXNOMBRE];
fstream in;
int num_votos;

  cout << "Introduzca nombre fichero entrada de datos: ";
  cin >> nombre_fichero_entrada;
  
  in.open(nombre_fichero_entrada, fstream::in);
  num_votos = LeerVotacion(in, gen);
  in.close();
  return num_votos;      
} /* cargarVotosDeFichero */

/* La funcin recibe como parmetros los votos y el nmero de votos a guardar */
void guardarVotosEnFichero(struct voto *gen, int num_votos) {
char nombre_fichero_salida[MAXNOMBRE];
fstream out;

  cout << "Introduzca nombre fichero salida de votos: ";
  cin >> nombre_fichero_salida;
  
  out.open(nombre_fichero_salida, fstream::out);
  EscribirVotacion(out, gen, num_votos);
  out.close();     
} /* guardarVotosEnFichero */

void mostrarPartidosCongreso(void) {
int i;
  cout << "Partidos posibles:" << endl;
  for (i = 0; i < PARTIDOS_CONGRESO; i++) 
    cout << i << ".- " << partidosCongreso[i] << endl;
} /* mostrarPartidosCongreso */

void mostrarSenadoresIsla(int isla, int tope) {
int i;
  cout << "Senadores posibles:" << endl;
  for (i = 0; i < tope; i++)
    switch (isla) {
       case 0: cout << i << ".- " << senadoresTenerife[i] << endl;
               break;
       case 1: cout << i << ".- " << senadoresGranCanaria[i] << endl;
               break;
       case 2: cout << i << ".- " << senadoresLaPalma[i] << endl;
               break;
       case 3: cout << i << ".- " << senadoresLaGomera[i] << endl;
               break;
       case 4: cout << i << ".- " << senadoresElHierro[i] << endl;
               break;
       case 5: cout << i << ".- " << senadoresLanzarote[i] << endl;
               break;
       case 6: cout << i << ".- " << senadoresFuerteventura[i] << endl;
               break;
     } /* switch */ 
} /* mostrarSenadoresIsla */

int numeroSenadoresIsla(int isla) {
int tope;
   switch (isla) {
     case 0: tope =  CANDIDATOS_SENADO_TENERIFE;
             break;
     case 1: tope =  CANDIDATOS_SENADO_GRANCANARIA;
             break;
     case 2: tope =  CANDIDATOS_SENADO_LAPALMA;
             break;
     case 3: tope =  CANDIDATOS_SENADO_LAGOMERA;
             break;
     case 4: tope =  CANDIDATOS_SENADO_ELHIERRO;
             break;
     case 5: tope =  CANDIDATOS_SENADO_LANZAROTE;
             break;
     case 6: tope =  CANDIDATOS_SENADO_FUERTEVENTURA;
             break;                                                                                                
  }    
  return tope;    
} /* numeroSenadoresIsla */

// Implemente una funcin 'votacion20N()' que solicit el nmero de votos que se van a emitir y cada uno de ellos.
int votacion20N(struct voto *votoActual) {
// Decidido por islas que Tenerife es 0 y Gran canaria es 1     
int i, k, tope_senado, tope_senadores, num_votantes;
   do {
     cout << "Indique numero de votantes en todas las islas (1 - " << CENSO << "): ";
       cin >> num_votantes;
   } while (num_votantes < 0 || num_votantes > CENSO-1);   

   for (i = 0; i < num_votantes; i++) {
       
     do {
       cout << "Indique isla del votante " << i+1 << ": ";
       cin >> votoActual[i].isla;
     } while (votoActual[i].isla  < 0 || votoActual[i].isla  > NUMERO_ISLAS-1);     
  
     if (votoActual[i].isla  < 2) // Islas mayores
       tope_senado = 2;
     else // Islas menores
       tope_senado = 1;
     tope_senadores = numeroSenadoresIsla(votoActual[i].isla);

     // Congreso  
     mostrarPartidosCongreso();
     do {       
       cout << "Su voto es para?: ";
       cin >> votoActual[i].congreso;
     } while (votoActual[i].congreso < 0 || votoActual[i].congreso > PARTIDOS_CONGRESO-1); 

     // Senado
     mostrarSenadoresIsla(votoActual[i].isla, tope_senadores);
     for (k = 0; k < tope_senado; k++)
       do {       
         cout << "Su voto " << k+1 << " es para?: ";
         cin >> votoActual[i].senado[k];
       } while (votoActual[i].senado[k] < 0 || votoActual[i].senado[k] > tope_senadores-1);
   } /* for */
   
   return num_votantes;    
} /* votacion20N */

void guardarEnResultadosVotacion(struct voto *votoActual, int num_votantes) {
// Decidido por islas que Tenerife es 0 y Gran canaria es 1     
int i, k, tope_senado;
   for (i = 0; i < num_votantes; i++) {
     (resultadosCongreso[votoActual[i].isla][votoActual[i].congreso])++;
  
     if (votoActual[i].isla < 2) // Islas mayores
       tope_senado = 2;
     else // Islas menores
       tope_senado = 1;
     for (k = 0; k < tope_senado; k++) 
       switch (votoActual[i].isla) {
         case 0: (resultadosSenadoTenerife[votoActual[i].senado[k]])++;
                 break;
         case 1: (resultadosSenadoGranCanaria[votoActual[i].senado[k]])++;
                 break;
         case 2: (resultadosSenadoLaPalma[votoActual[i].senado[k]])++;
                 break;
         case 3: (resultadosSenadoLaGomera[votoActual[i].senado[k]])++;
                 break;
         case 4: (resultadosSenadoElHierro[votoActual[i].senado[k]])++;
                 break;
         case 5: (resultadosSenadoLanzarote[votoActual[i].senado[k]])++;
                 break;
         case 6: (resultadosSenadoFuerteventura[votoActual[i].senado[k]])++;
                 break;                                                                                                
       } /* switch */                 
   } /* for */    
} /* guardarEnResultadosVotacion */


